$regfile = "m16def.dat"
$crystal = 16000000

'Konfiguracja nek
Config Porta = Input
'A.0 - Przycisk - tryb 3
'A.1 - Przycisk - wstecz
'A.2 - Przycisk - ustawienia 7-seg
'A.3 - Przycisk - ustawienia przycisku nonego
'A.4 - Pomiar napicia na przycisku nonym
'A.5 - Pomiar napicia przy rozpoznawaniu typu przycisku nonego
'A.6 - Pomiar pobieranego prdu
'A.7 - Pomiar napicia zasilania

Config Pinb.0 = Input                                       'Przycisk - tryb 2
Config Pinb.1 = Input                                       'Przycisk - tryb 1
Config Pinb.2 = Output                                      'LED 3
Config Pinb.3 = Output                                      'LED 2
Config Pinb.4 = Output                                      'LED 1
Config Pinb.5 = Output                                      'MOSI - dane 7-seg
Config Pinb.6 = Input                                       'MISO - nieuywane, pull-up
Config Pinb.7 = Output                                      'CKL 7-seg

Config Pinc.0 = Output                                      'LCD - DB4
Config Pinc.1 = Output                                      'LCD - DB5
Config Pinc.2 = Output                                      'LCD - DB6
Config Pinc.3 = Output                                      'LCD - DB7
Config Pinc.4 = Input                                       'impulsator - wyjcie A
Config Pinc.5 = Output                                      'przycisk nony - zwieranie do masy (tylko pynny)
Config Pinc.6 = Output                                      'przycisk nony - pull-down (tylko skokowy)
Config Pinc.7 = Input                                       'wykrycie podczenia przycisku nonego

Config Pind.0 = Output                                      'wczanie wywietlaczy 7-seg
Config Pind.1 = Output                                      'adowanie danych do 7-seg z rejestrw
Config Pind.2 = Input                                       'impulsator - wyjcie B (INT0)
Config Pind.3 = Input                                       'impulsator - przycisk (INT1)
Config Pind.4 = Output                                      'kolor 7-seg (PWM B)
Config Pind.5 = Output                                      'sterowanie PWM silnikiem (PWM A)
Config Pind.6 = Output                                      'LCD - RS
Config Pind.7 = Output                                      'LCD - E

'Aliasy
Sw3 Alias Pina.0
Swback Alias Pina.1
Sw7seg Alias Pina.2
Swfoot Alias Pina.3
Sw2 Alias Pinb.0
Sw1 Alias Pinb.1
Led3 Alias Portb.2
Led2 Alias Portb.3
Led1 Alias Portb.4
Impb Alias Pinc.4
Footster Alias Portc.5
Footster2 Alias Portc.6
Footplug Alias Pinc.7
7segon Alias Portd.0
Strobe7seg Alias Portd.1
Swimp Alias Pind.3

'(
STANDARDOWY PEDA EKSPRESJI/GONOCI - odpowiednik potencjometru - WTYK JACK
CW -> sleeve
Wiper -> tip
CCW -> ring
')

'Deklaracja zmiennych
Dim 7seg(2) As Byte                                         'Dane wywietlane na 7-seg
Dim Key As Byte                                             'Nacinity przycisk
Dim Obrot_imp As Byte                                       'Obrt impulsatora (0 - brak, 1 - CW, 2 - CCW)
Dim Odlicz_debounce As Byte                                 'Odliczanie - eliminacja drga stykw
Dim Tryb As Byte                                            'Tryb pracy
Dim Menu As Byte                                            'Bieca pozycja w menu (0 - normalna praca)
Dim Pn As Byte                                              'obecno i typ przecznika nonego
Dim Pm As Byte                                              'Zmienna pomocnicza przy obliczeniach
Dim Pm2 As Byte                                             'zmienna pomocnicza 2
Dim Obr_biez As Byte                                        'Biece obroty 0-15
Dim Obr1 As Byte                                            'Obroty w trybie 1 przy zwolnionym przycisku nonym
Dim Obr1pn As Byte                                          'Obroty w trybie 1 przy nacinitym przycisku nonym
Dim Obr2 As Byte                                            'Obroty w trybie 2 przy zwolnionym przycisku nonym
Dim Obr2pn As Byte                                          'Obroty w trybie 2 przy nacinitym przycisku nonym do oporu
Dim Obr3 As Byte                                            'Obroty w trybie 3 przy zwolnionym PN i bez obcienia
Dim Obr3obc As Byte                                         'Obroty w trybie 3 przy zwolnionym PN i z obcieniem
Dim Obr3pn As Byte                                          'Obroty w trybie 3 przy nacinitym przycisku nonym
Dim Prad_gran As Byte                                       'prd graniczny w trybie 3 (powyej ktrego zwikszane s obroty) x100
Dim Kolor7seg As Byte                                       'Wybrana opcja koloru 7-seg
Dim Tresc7seg As Byte                                       'Tre (.1) i w/wy (.0) wywietlaczy 7-seg
Dim Odlicz_pomiar As Byte                                   'Opnienie w wykonywanych pomiarach
Dim Odlicz_blysk As Byte                                    'Odliczanie mrugnicia diod po podczeniu i rozpoznaniu typu pedau
Dim Nap_int As Byte                                         'Napicie zasilania - cz cakowita
Dim Nap_frac As Byte                                        'Napicie zasilania - cz dziesitna
Dim Prad_int As Byte                                        'Prd - cz cakowita
Dim Prad_frac As Byte                                       'Prd - cz dziesitna
Dim Pn_value As Integer                                     'warto z przycisku nonego lub wyznaczania jego typu
Dim Expr_max As Integer                                     'Maksymalna warto na pedale ekspresji
Dim Expr_min As Integer                                     'Minimalna warto na pedale ekspresji
Dim Expr_skok As Integer                                    'prg w trybie skokowym pedau ekspresji
Dim Expr_fun As Integer                                     'warto ADC pedau pynnego, narastajca od zera w funkcji siy nacisku (=ADC-expr_min lub =expr_max-ADC zalenie od polaryzacji)
Dim Expr_diff As Integer                                    'Rnica Expr_max - Expr_min
Dim Prad As Integer                                         'Pobierany prd z wyjcia x100
Dim Odlicz_pn As Integer                                    'Opnienie przy podczaniu/odczaniu pedau
Dim Odlicz_eeprom As Integer                                'opnienie przy wpisywaniu niektrych danych do EEPROMu, aby nie zarn pamici za szybko (jak nastawy obrotw impulsatorem)
Dim Update_eeprom As Byte                                   'co naley zaktualizowa w EEPROMie
Dim Update_eeprom2 As Byte                                  'druga zmienna, analogiczna do powyszej - zawiera pozycje z poziomw ustawie w menu. Opnienie nie jest potrzebne
Dim Pm_int As Integer                                       'Zmienna pomocnicza 16-bitowa
Dim Nap As Long                                             'Napicie zasilania x10 (dopiero ten typ danych nie wprowadza duych bdw zaokrglenia)
Dim Polaryzacja As Bit                                      'Polaryzacja pedau
Dim K1 As Bit                                               'Kropka na wywietlaczu 7-seg lewym
Dim K2 As Bit                                               'Kropka na wywietlaczu 7-seg prawym
Dim Pn_push As Bit                                          'peda nacinity (sustain lub pynny w trybie skokowym)
Dim Zwolniono As Bit                                        'Czy wszystkie przyciski s zwolnione?
Dim Odswiez_7seg As Bit                                     'Odwie zawarto wywietlaczy 7-seg
Dim Odswiez_lcd As Bit                                      'Odwie dane na LCD
Dim Update_lcd As Bit                                       'Naley cakowicie wyczyci LCD i odwiey
Dim Odswiez_pom As Bit                                      'Wykonaj nowe pomiary
'Zmienne w pamici EEPROM
Dim E_obr1 As Eram Byte
Dim E_obr1pn As Eram Byte
Dim E_obr2 As Eram Byte
Dim E_obr2pn As Eram Byte
Dim E_obr3 As Eram Byte
Dim E_obr3obc As Eram Byte
Dim E_obr3pn As Eram Byte
Dim E_kolor7seg As Eram Byte
Dim E_tresc7seg As Eram Byte
Dim E_prad_gran As Eram Byte
Dim E_polar As Eram Byte
Dim E_expr_min As Eram Integer
Dim E_expr_max As Eram Integer
Dim E_expr_skok As Eram Integer

'Tryb = 0 - tryb stay, moliwo regulacji skokowej pedaem [w komentarzach jako tryb nr 1]
'Tryb = 1 - regulacja pynna pedaem [2]
'Tryb = 2 - regulacja obcieniem, moliwo regulacji skokowej pedaem [3]

'Aktualizacje w EEPROM - zmienna Update_eeprom - czyli co naley zapisa:
'bit 0 - Obr1
'bit 1 - Obr1pn
'bit 2 - Obr2
'bit 3 - Obr2pn
'bit 4 - Obr3
'bit 5 - Obr3pn
'bit 6 - co jest z drugiej zmiennej (update_eeprom2)

'Analogiczna zmienna Update_eeprom2
'bit 0 - Obr3obc
'bit 1 - kolor7seg
'bit 2 - tresc7seg
'bit 3 - prad_gran
'bit 4 - expr_min
'bit 5 - expr_max
'bit 6 - expr_skok

'stae
Const Debounce_ms = 15                                      'eliminacja drga stykw - opnienie w milisekundach
Const Pn_plug_in = 700                                      'opnienie rozpoznawania przecznika nonego po podczeniu
Const Pn_plug_out = 50                                      'opnienie przy odczeniu przecznika nonego
Const Led_flash = 170                                       'czas mrugnicia diody po podczeniu i rozpoznaniu pedau
Const Eeprom_write = 1500                                   'czas bezczynnoci po jakim zmiany bd wprowadzone do EEPROMu

'pull-upy
Set Porta.0
Set Porta.1
Set Porta.2
Set Porta.3
Set Portb.0
Set Portb.1
Set Portb.6

 'konfiguracja wywietlacza LCD
Config Lcd = 16 * 2
Config Lcdpin = Pin , E = Portd.7 , Rs = Portd.6 , Db4 = Portc.0 , Db5 = Portc.1 , Db6 = Portc.2 , Db7 = Portc.3
Cls
Cursor Off

'wczytaj i ustaw wartoci zmiennych
If E_obr1 = 255 Then                                        'pierwsze uruchomienie - w EEPROMie same jedynki, trzeba je ustawi na wartoci domylne
   E_obr1 = 0
   Bitwait Eecr.1 , Reset
   E_obr1pn = 15
   Bitwait Eecr.1 , Reset
   E_obr2 = 0
   Bitwait Eecr.1 , Reset
   E_obr2pn = 15
   Bitwait Eecr.1 , Reset
   E_obr3 = 0
   Bitwait Eecr.1 , Reset
   E_obr3obc = 15
   Bitwait Eecr.1 , Reset
   E_obr3pn = 15
   Bitwait Eecr.1 , Reset
   E_kolor7seg = 16
   Bitwait Eecr.1 , Reset
   E_tresc7seg = 1
   Bitwait Eecr.1 , Reset
   E_prad_gran = 10
   Bitwait Eecr.1 , Reset
   E_polar = 0
   Bitwait Eecr.1 , Reset
   E_expr_min = 50
   Bitwait Eecr.1 , Reset
   E_expr_max = 1013
   Bitwait Eecr.1 , Reset
   E_expr_skok = 532
   Bitwait Eecr.1 , Reset
End If
'Uruchomienie - wczytaj ustawienia, kalibracje i nastawy z pamici EEPROM
Obr1 = E_obr1
Obr1pn = E_obr1pn
Obr2 = E_obr2
Obr2pn = E_obr2pn
Obr3 = E_obr3
Obr3obc = E_obr3obc
Obr3pn = E_obr3pn
Kolor7seg = E_kolor7seg
Tresc7seg = E_tresc7seg
Prad_gran = E_prad_gran
Expr_min = E_expr_min
Expr_max = E_expr_max
Expr_skok = E_expr_skok
7seg(1) = 10
7seg(2) = 10
Set Odswiez_7seg
Set Odswiez_lcd
Set Odswiez_pom
Set Led1

Deflcdchar 0 , 32 , 16 , 8 , 4 , 2 , 25 , 31 , 32           'przycisk nony zwolniony
Deflcdchar 1 , 32 , 32 , 32 , 28 , 2 , 25 , 31 , 32         'przycisk nony nacinity
Deflcdchar 2 , 12 , 4 , 6 , 12 , 4 , 4 , 14 , 32            'polskie ""
Deflcdchar 3 , 32 , 32 , 14 , 1 , 15 , 17 , 15 , 2          'polskie ""
Deflcdchar 4 , 31 , 31 , 14 , 14 , 4 , 4 , 31 , 27          'wiertarka pod obcieniem
Deflcdchar 5 , 31 , 31 , 14 , 14 , 4 , 4 , 4 , 32           'wiertarka bez obcienia
Deflcdchar 6 , 2 , 4 , 14 , 16 , 14 , 1 , 30 , 32           'polskie ""
Deflcdchar 7 , 2 , 4 , 14 , 16 , 16 , 17 , 14 , 32          'polskie ""

'konfiguracja ADC
Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'konfiguracja przerwania INT0 - obrt impulsatora
Config Int0 = Rising
On Int0 Obrot
Enable Int0

'konifguracja Timer0 - generator przerwa ok. 1kHz
Config Timer0 = Timer , Prescale = 64
On Timer0 Czas
Enable Timer0

'konfiguracja Timer1 - generator PWM
Config Timer1 = Pwm , Pwm = 8 , Compare A Pwm = Clear_up , Compare B Pwm = Clear_up , Prescale = 8
Enable Timer1

'konfiguracja SPI - obsluga wywietlaczy 7-seg
Config Spi = Hard , Data Order = Lsb , Interrupt = On , Master = Yes , Polarity = Low , Clockrate = 16 , Noss = 1
Spiinit

Enable Interrupts

Do
If Odswiez_pom = 1 Then
   Reset Odswiez_pom
   Prad = Getadc(6)                                         'POMIAR PRDU WYJCIOWEGO
   Prad = Prad \ 2                                          'prd x100 (docelowy format x.xx)
   Prad_int = Prad \ 100
   Pm_int = Prad_int * 100
   Prad_frac = Prad - Pm_int

   Nap = Getadc(7)                                          'POMIAR NAPICIA ZASILANIA
   Nap = Nap * 300
   Nap = Nap \ 1023
   Nap_int = Nap \ 10
   Nap_frac = Nap_int * 10
   Nap_frac = Nap - Nap_frac

   'detekcja i obsuga przycisku nonego
   If Pn = 0 Then
      If Footplug = 0 Then                                  'co wanie zostao podczone
         Pn = 4
         Odlicz_pn = Pn_plug_in
      End If
   Elseif Pn < 4 Then                                       'normalna obsuga pedau lub oczekiwanie na odczenie pedau niewspieranego
      Reset Pn_push
      Pn_value = Getadc(4)
      If Pn = 1 Then                                        'peda skokowy
         If Pn_value < 421 Then
         Else
            Set Pn_push
         End If
         If Polaryzacja = 1 Then
            Toggle Pn_push
         End If
      Elseif Pn = 2 Then                                    'peda pynny (ekspresji)
         If Pn_value > Expr_skok Then                       'wyznaczanie bitu dla trybu skokowego
            Set Pn_push
         End If
         If Polaryzacja = 0 Then                            'peda o charakterystyce narastajej napicia wyjciowego
            If Pn_value < Expr_min Then                     'warto mniejsza ni wyznaczony zakres - na wyjciu zero
               Expr_fun = 0
            Elseif Pn_value < Expr_max Then                 'warto w wyznaczonym zakresie - licz normalnie
               Expr_fun = Pn_value - Expr_min
            Else                                            'warto powyej wyznaczonego zakresu - na wyjciu max-min
               Expr_fun = Expr_max - Expr_min
            End If
         Else                                               'peda o charakterystyce opadajcej napicia wyjciowego
            Toggle Pn_push
            If Pn_value > Expr_max Then
               Expr_fun = 0
            Elseif Pn_value > Expr_min Then
               Expr_fun = Expr_max - pn_value
            Else
               Expr_fun = Expr_max - Expr_min
            End If
         End If
         Expr_diff = Expr_max - Expr_min
      End If
      If Footplug = 1 Then                                  'wanie odczylimy
         Pn = 6
         Reset Footster
         Reset Footster2
         Odlicz_pn = Pn_plug_out
         Reset Pn_push
         Pn_value = 0
         If Menu > 9 And Menu < 13 Then                     'jeli weszlimy w ustawienia pedau, wychodzimy z nich
            Menu = 0
         End If
         Set Update_lcd                                     'odwiey LCD
         Set Odswiez_lcd
      End If
   Elseif Pn = 5 Then                                       'gotowy do wyznaczenia typu pedau
      If Footplug = 0 Then
         Pn_value = Getadc(5)                               'linia FOOT-TYP na schemacie
         If Pn_value > 980 Then                                'peda skokowy (sustain)
            Set Footster2
            Pn = 1
            Set Update_lcd
            Set Odswiez_lcd
            'rozpoznaj polaryzacj
            Pn_value = Getadc(4)
            If Pn_value < 421 Then
               Reset Polaryzacja                            'przecznik NO
            Else
               Set Polaryzacja                                 'przecznik NC
            End If
            'mrugnij diod
            Toggle Led1
            Odlicz_blysk = Led_flash
         Elseif Pn_value > 30 Then                             'peda pynny (ekspresji/gonoci)
            Set Footster
            If E_polar = 0 Then
               Reset Polaryzacja
            Else
               Set Polaryzacja
            End If
            Expr_min = E_expr_min
            Expr_max = E_expr_max
            Pn = 2
            Set Update_lcd
            Set Odswiez_lcd
            Toggle Led2
            Odlicz_blysk = Led_flash
         Else                                                  'peda nieobsugiwany - bd
            Pn = 3
         End If
      Else
         Pn = 6
         Odlicz_pn = Pn_plug_out                            'brak wtyczki pedau - odlicz chwil i powr do trybu oczekiwania
      End If
   End If

   'Obsuga obrotw silnika wiertarki
   If Menu = 0 Then                                         'obroty tylko kiedy menu=0
      If Tryb = 0 Then
         If Pn_push = 0 Then
            Obr_biez = Obr1
         Else
            Obr_biez = Obr1pn
         End If
      Elseif Tryb = 1 Then                                  'pynnie regulowane obroty
         If Pn = 2 Then
            If Obr2pn > Obr2 Then                              'obroty mona te pynnie zmniejsza, kto komu zabroni!
               Pm = Obr2pn - obr2
            Else
               Pm = Obr2 - obr2pn
            End If
            Pm_int = Pm * Expr_fun
            Pm_int = Pm_int * 2
            Pm_int = Pm_int \ Expr_diff
            Pm = Obr2 * 2
            If Obr2pn > Obr2 Then
               Pm = Pm_int + Pm
            Else
               Pm = Pm - Pm_int
            End If
            Obr_biez = Pm \ 2
         Else                                               'po nagym odczeniu pedau natychmiast zatrzymaj silnik
            Obr_biez = 0
         End If
      Elseif Tryb = 2 Then                                  'Tryb sprawdzajcy obcienie
         If Pn_push = 1 Then
            Obr_biez = Obr3pn
         Elseif Prad < Prad_gran Then                       'po przekroczeniu prdu granicznego wcz wysze obroty
            Obr_biez = Obr3
         Else
            Obr_biez = Obr3obc
         End If
      End If
   Else                                                     'w ustawieniach i menu zawsze wycz wiertark
      Obr_biez = 0
   End If
   Pwm1a = Obr_biez * 17                                    'Wpisz ostateczn warto do generatora PWM

   'Obsuga koloru wywietlaczy 7-seg
   Pm = Kolor7seg And &B00110000
   Shift Pm , Right , 4
   If Pm = 0 Then                                           'kolor stay
      Pm = Kolor7seg And &B00001111
      Pwm1b = Pm * 17
   Elseif Pm = 1 Then                                       'kolor zaleny od prdu obcienia
      Pm = Prad \ 10                                        'wychodzi prd x10 (np. PM=10 -> 1A)
      If Pm < 2 Then
         Pwm1b = 0                                          'may prd - kolor zielony
      Elseif Pm < 19 Then                                   'prd z zakresu kolorowanego - pynna barwa
         Pm = Pm - 2
         Pwm1b = Pm * 15
      Else
         Pwm1b = 255                                        'duy prd - kolor czerwony
      End If
   Elseif Pm = 2 Then                                       'kolor zaleny od obrotw
      Pwm1b = Obr_biez * 17
   Else                                                     'kolor zaleny od pozycji pedau
      If Pn = 1 And Menu <> 11 Then                         'peda skokowy
         If Pn_push = 0 Then
            Pwm1b = 0
         Else
            Pwm1b = 255
         End If
      Elseif Pn = 2 And Menu <> 11 Then                     'peda ekspresji
         Pm_int = Expr_fun * 17
         Pm_int = Pm_int \ Expr_diff
         Pwm1b = Pm_int * 15
      Else
         Pwm1b = 0                                          'jeli nie ma podczonego pedau, kolor zielony
      End If
   End If
   Set Odswiez_lcd
   Set Odswiez_7seg
End If

'Przetwrz i wylij dane z tablicy 7seg
If Odswiez_7seg = 1 Then
   Reset Odswiez_7seg
   Reset K1
   If Menu <> 30 Then                                       'normalne wywietlanie treci
      If Tresc7seg = 1 Then                                 'wywietlanie biecych obrotw
         Pm = Makebcd(obr_biez)
         7seg(1) = Pm And &B00001111
         7seg(2) = Pm And &B11110000
         Shift 7seg(2) , Right , 4
      Elseif Tresc7seg = 3 Then                             'wywietlanie prdu
         7seg(2) = Prad_int
         7seg(1) = Prad_frac \ 10
         Set K1
      Else                                                  'wywietlacze wyczone
         7seg(2) = 10
         7seg(1) = 10
      End If
      If 7seg(2) = 0 And K1 = 0 Then                        'ukryj zero na pierwszym wywietlaczu, o ile nie ma na nim kropki dziesitnej
         7seg(2) = 10
      End If
      7seg(2) = Lookup(7seg(2) , Kody7seg)
      7seg(1) = Lookup(7seg(1) , Kody7seg)
      If K1 = 1 Then                                        'zawiecanie kropek
         Reset 7seg(2).0
      End If
      If K2 = 1 Then
         Reset 7seg(1).0
      End If
   Else                                                     'wybieranie koloru staego - semki z kropkami dla uatwienia i bajeru
      7seg(1) = &B00000000
      7seg(2) = &B00000000
   End If
   Disable Timer0
   Disable Timer1
   Disable Int0
   Spiout 7seg(1) , 2
   Enable Timer0
   Enable Timer1
   Enable Int0
   Set Strobe7seg
   Reset Strobe7seg
   Set 7segon
End If

'Obsuga obrotw impulsatora
If Obrot_imp > 0 Then
   If Menu = 10 Then
      Toggle Polaryzacja
   Elseif Menu = 20 Then
      Toggle Tresc7seg.0
      Set Odswiez_7seg
   Elseif Menu = 21 Then
      Toggle Tresc7seg.1
      set odswiez_7seg
   Elseif Menu = 22 Then
      Pm = Kolor7seg And &B00110000
      Shift Pm , Right , 4
      If Obrot_imp = 1 Then
         Incr Pm
         If Pm = 4 Then
            Pm = 0
         End If
      Else
         If Pm = 0 Then
            Pm = 3
         Else
            Decr Pm
         End If
      End If
      Shift Pm , Left , 4
      Kolor7seg = Kolor7seg And &B11001111
      Kolor7seg = Kolor7seg Or Pm
      set odswiez_7seg
   Elseif Menu = 30 Then
      Pm = Kolor7seg And &B00001111
      If Obrot_imp = 1 Then
         Incr Pm
         If Pm = 16 Then
            Pm = 0
         End If
      Else
         If Pm = 0 Then
            Pm = 15
         Else
            Decr Pm
         End If
      End If
      Kolor7seg = Kolor7seg And &B00110000
      Kolor7seg = Kolor7seg Or Pm
   Elseif Tryb = 0 Then
      If Pn_push = 0 Then
         If Obrot_imp = 1 Then
            If Obr1 < 15 Then
               Incr Obr1
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.0
            End If
         Else
            If Obr1 > 0 Then
               Decr Obr1
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.0
            End If
         End If
      Else
         If Obrot_imp = 1 Then
            If Obr1pn < 15 Then
               Incr Obr1pn
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.1
            End If
         Else
            If Obr1pn > 0 Then
               Decr Obr1pn
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.1
            End If
         End If
      End If
      Set Odswiez_7seg
   Elseif Tryb = 1 Then
      If Pn_push = 0 Then
         If Obrot_imp = 1 Then
            If Obr2 < 15 Then
               Incr Obr2
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.2
            End If
         Else
            If Obr2 > 0 Then
               Decr Obr2
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.2
            End If
         End If
      Else
         If Obrot_imp = 1 Then
            If Obr2pn < 15 Then
               Incr Obr2pn
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.3
            End If
         Else
            If Obr2pn > 0 Then
               Decr Obr2pn
               Odlicz_eeprom = Eeprom_write
               Set Update_eeprom.3
            End If
         End If
      End If
      Set Odswiez_7seg
   Elseif Tryb = 2 Then
      If Menu = 0 Then
         If Pn_push = 0 Then
            If Obrot_imp = 1 Then
               If Obr3 < 15 Then
                  Incr Obr3
                  If Obr3 > Obr3obc Then
                     Obr3obc = Obr3
                     Set Update_eeprom2.0
                     Set Update_eeprom.6
                  End If
                  Odlicz_eeprom = Eeprom_write
                  Set Update_eeprom.4
               End If
            Else
               If Obr3 > 0 Then
                  Decr Obr3
                  Odlicz_eeprom = Eeprom_write
                  Set Update_eeprom.4
               End If
            End If
         Else
            If Obrot_imp = 1 Then
               If Obr3pn < 15 Then
                  Incr Obr3pn
                  Odlicz_eeprom = Eeprom_write
                  Set Update_eeprom.5
               End If
            Else
               If Obr3pn > 0 Then
                  Decr Obr3pn
                  Odlicz_eeprom = Eeprom_write
                  Set Update_eeprom.5
               End If
            End If
         End If
      Elseif Menu = 1 Then                                  'regulacja prdu granicznego
         If Obrot_imp = 1 Then
            If Prad_gran < 15 Then
               Incr Prad_gran
            Elseif Prad_gran < 50 Then
               Prad_gran = Prad_gran + 5
            Elseif Prad_gran < 250 Then
               Prad_gran = Prad_gran + 10
            End If
         Else
            If Prad_gran > 50 Then
               Prad_gran = Prad_gran - 10
            Elseif Prad_gran > 15 Then
               Prad_gran = Prad_gran - 5
            Elseif Prad_gran > 1 Then
               Decr Prad_gran
            End If
         End If
      Elseif Menu = 2 Then                                  'regulacja obrotw po naciniciu pedau
         If Obrot_imp = 1 Then
            If Obr3obc < 15 Then
               Incr Obr3obc
            End If
         Else
            If Obr3obc > Obr3 Then                          'nie mog by mniejsze ni obroty bez obcienia!
               Decr Obr3obc
            End If
         End If
      End If
   End If
   Obrot_imp = 0
   Set Odswiez_lcd
End If

'Odwieanie danych na LCD
If Odswiez_lcd = 1 Then
   Reset Odswiez_lcd
   If Update_lcd = 1 Then
      Reset Update_lcd
      Cls
   End If
   Locate 1 , 1
   If Menu < 10 Then
      If Tryb = 0 Then
         If Pn = 1 Or Pn = 2 Then
            Locate 2 , 1
            Lcd Chr(1) ; " " ; Obr1pn ; "/15 "
            Locate 1 , 1
            Lcd Chr(0) ; " "
         End If
         Lcd Obr1 ; "/15 "
         Locate 1 , 11
         Lcd Prad_int ; "."
         If Prad_frac < 10 Then
            Lcd "0"
         End If
         Lcd Prad_frac ; " A "
         Locate 2 , 11
         Lcd Nap_int ; "." ; Nap_frac ; " V "
      Elseif Tryb = 1 Then
         If Pn = 2 Then
            Lcd Chr(0)
            Locate 1 , 3
            Lcd Obr2 ; "/15 "
            Locate 1 , 11
            Lcd Prad_int ; "."
            If Prad_frac < 10 Then                          'dopisz pierwsze zero po przecinku
               Lcd "0"
            End If
            Lcd Prad_frac ; " A "
            Locate 2 , 1
            Lcd Chr(1) ; " " ; Obr2pn ; "/15 "
            Locate 2 , 11
            Lcd Nap_int ; "." ; Nap_frac ; " V "
         Else                                                  'brak pedau ekspresji - wywietl informacj
            Lcd " Pod" ; Chr(2) ; Chr(3) ; "cz peda" ; Chr(2)
            Locate 2 , 4
            Lcd "ekspresji"
         End If
      Elseif Tryb = 2 Then
         If Menu = 0 Then                                      'podstawowy tryb wywietlania
            Lcd Chr(5) ; " " ; Obr3 ; "/15 "
            Locate 1 , 11
            Lcd Prad_int ; "."
            If Prad_frac < 10 Then
               Lcd "0"
            End If
            Lcd Prad_frac ; " A "
            Locate 2 , 1
            Lcd Chr(4) ; " " ; Obr3obc ; "/15 "
            Locate 2 , 9
            If Pn_push = 0 Then                                'wyswietlanie prdu granicznego
               Pm = Prad_gran \ 100                         'ampery
               Pm2 = Pm * 100
               Pm2 = Prad_gran - Pm2                        'setne czci ampera
               Lcd Chr(4) ; " " ; Pm ; "."
               If Pm2 < 10 Then
                  Lcd "0"
               End If
               Lcd Pm2 ; " A "
            Else                                            'wywietl obroty po naciniciu pedau
               Lcd Chr(1) ; " " ; Obr3pn ; "/15  "
            End If
         Elseif Menu = 1 Then                                  'ustawienia prdu granicznego
            Locate 1 , 2
            Lcd "pr" ; Chr(3) ; "d graniczny"
            Locate 2 , 9
            Pm = Prad_gran \ 100                            'ampery
            Pm2 = Pm * 100
            Pm2 = Prad_gran - Pm2                           'setne czci ampera
            Lcd Chr(4) ; " " ; Pm ; "."
            If Pm2 < 10 Then
               Lcd "0"
            End If
            Lcd Pm2 ; " A "
         Elseif Menu = 2 Then                                  'ustawienia prdkoci pod obcieniem
            Lcd "obroty pod obc."
            Locate 2 , 1
            Lcd Chr(4) ; " " ; Obr3obc ; "/15 "
         End If
      End If
   Else                                                     'weszlimy w ustawienia i konfiguracje
      If Menu = 10 Then
         Lcd "Polar. peda" ; Chr(2) ; "u  "
         If Pn_push = 0 Then                                'wywietl ikonk uatwiajc ustawianie
            Lcd Chr(0)
         Else
            Lcd Chr(1)
         End If
         Locate 2 , 2
         If Polaryzacja = 0 Then
            Lcd "> NO"
         Else
            Lcd "> NC"
         End If
      Elseif Menu = 12 Then
         Lcd "ustaw punkt tr."
         Locate 2 , 1
         Lcd "skok. i OK  " ; Pn_value ; "   "
      Elseif Menu = 11 Then
         If Pn_value < Expr_min Then
            Expr_min = Pn_value
         End If
         If Pn_value > Expr_max Then
            Expr_max = Pn_value
         End If
         Pm_int = Expr_min + Expr_max
         Pm_int = Pm_int \ 2
         If Pm_int > Pn_value Then                          'zakadajc, e peda jest zwolniony, wywietl ikonki odpowiadajce pozycjom
            Pm = 1
         Else
            Pm = 0
         End If
         Pm_int = Expr_max - Expr_min                       'sprawd, czy dotychczasowy zakres jest odpowiednio wysoki
         If Pm_int > 200 Then
            Pm2 = 1
         Else
            Pm2 = 0
         End If
         Lcd "wci" ; Chr(6) ; "nij, zwolnij"
         Locate 2 , 1
         Lcd "i OK "
         If Pm2 = 1 Then
            If Pm = 0 Then                                  'warto "expr_min" odpowiada wcinitemu pedaowi
               Lcd Chr(1) ; Expr_min ; "   "
               Locate 2 , 12
               Lcd Chr(0) ; Expr_max ; "   "
            Else                                            'warto "expr_max" odpowiada wcinitemu pedaowi
               Lcd Chr(0) ; Expr_min ; "   "
               Locate 2 , 12
               Lcd Chr(1) ; Expr_max ; "   "
            End If
         Else
            Lcd " " ; Expr_min ; "   "
            Locate 2 , 12
            Lcd " " ; Expr_max ; "   "
         End If
      Elseif Menu = 20 Then
         Lcd "Wy" ; Chr(6) ; "w. 7-seg"
         Locate 2 , 2
         If Tresc7seg.0 = 0 Then
            Lcd "> wy" ; Chr(2) ; Chr(3) ; "czone"
         Else
            Lcd "> w" ; Chr(2) ; Chr(3) ; "czone "
         End If
      Elseif Menu = 21 Then
         Locate 1 , 1
         Lcd "Tre" ; Chr(6) ; Chr(7) ; " 7-seg"
         Locate 2 , 2
         If Tresc7seg.1 = 0 Then                            'obroty
            Lcd "> obroty   "
         Else
            Lcd "> pr" ; Chr(3) ; "d obc."
         End If
      Elseif Menu = 22 Then
         Lcd "Kolor 7-seg"
         Pm = Kolor7seg And &B00110000
         Shift Pm , Right , 4
         Locate 2 , 2
         If Pm = 0 Then                                     'kolor stay
            Pm2 = Kolor7seg And &B00001111                  'wycignij nastaw ze zmiennej
            Lcd "> sta" ; Chr(2) ; "y    "
            If Pm2 < 10 Then
               Locate 2 , 13
            Else
               Locate 2 , 12
            End If
            Lcd Pm2 ; "/15 "
         Elseif Pm = 1 Then                                 'zaleny od prdu obcienia
            Lcd "> pr" ; Chr(3) ; "d obc.    "
         Elseif Pm = 2 Then                                 'zaleny od obrotw
            Lcd "> obroty       "
         Elseif Pm = 3 Then                                 'zaleny od pozycji pedau
            Lcd "> peda" ; Chr(2) ; "        "
         End If
      Elseif Menu = 30 Then
         Lcd "Kolor 7-seg"
         Locate 2 , 2
         Pm2 = Kolor7seg And &B00001111
         Lcd "  sta" ; Chr(2) ; "y  > "
         If Pm2 < 10 Then
            Locate 2 , 13
         Else
            Locate 2 , 12
         End If
         Lcd Pm2 ; "/15 "
      End If
   End If
End If

'Obsluga klawiatury
If Key = 0 Then
   If Sw1 = 0 Then
      Key = 8
      Odlicz_debounce = Debounce_ms
   Elseif Sw2 = 0 Then
      Key = 9
      Odlicz_debounce = Debounce_ms
   Elseif Sw3 = 0 Then
      Key = 10
      Odlicz_debounce = Debounce_ms
   Elseif Swback = 0 Then
      Key = 11
      Odlicz_debounce = Debounce_ms
   Elseif Sw7seg = 0 Then
      Key = 12
      Odlicz_debounce = Debounce_ms
   Elseif Swfoot = 0 Then
      Key = 13
      Odlicz_debounce = Debounce_ms
   Elseif Swimp = 0 Then
      Key = 14
      Odlicz_debounce = Debounce_ms
   End If
Elseif Key = 1 Then                                         'wejcie w tryb 1
   'aktualizacje EEPROMu jeli bylimy akurat w jakich ustawieniach
   If Menu = 1 Then                                      'aktualizuj prad_gran
      Set Update_eeprom.6
      Set Update_eeprom2.3
   Elseif Menu = 2 Then                                     'aktualizuj obr3obc
      Set Update_eeprom.6
      Set Update_eeprom2.0
   Elseif Menu = 11 Then                                    'anulowano kalibracj zakresu pedau pynnego - wczytaj z EEPROMu poprzednie nastawy
      Expr_min = E_expr_min
      Expr_max = E_expr_max
      If E_polar = 0 Then
         Reset Polaryzacja
      Else
         Set Polaryzacja
      End If
   Elseif Menu = 12 Then                                    'anulowano wskazanie progu skokowego pedau pynnego - wczytaj z EEPROMu poprzedni nastaw
      Expr_skok = E_expr_skok
   Elseif Menu = 20 Or Menu = 21 Then                       'aktualizuj tresc7seg
      Set Update_eeprom.6
      Set Update_eeprom2.2
   Elseif Menu = 22 Or Menu = 30 Then                       'aktualizuj kolor7seg
      Set Update_eeprom.6
      Set Update_eeprom2.1
   End If
   Tryb = 0
   Key = 15
   Menu = 0
   Odlicz_blysk = 0
   Reset Led2
   Reset Led3
   Set Led1
   Set Update_lcd
   Set Odswiez_lcd
Elseif Key = 2 Then                                         'wejcie w tryb 2
   'aktualizacje EEPROMu jeli bylimy akurat w jakich ustawieniach
   If Menu = 1 Then                                      'aktualizuj prad_gran
      Set Update_eeprom.6
      Set Update_eeprom2.3
   Elseif Menu = 2 Then                                     'aktualizuj obr3obc
      Set Update_eeprom.6
      Set Update_eeprom2.0
   Elseif Menu = 11 Then                                    'anulowano kalibracj zakresu pedau pynnego - wczytaj z EEPROMu poprzednie nastawy
      Expr_min = E_expr_min
      Expr_max = E_expr_max
      If E_polar = 0 Then
         Reset Polaryzacja
      Else
         Set Polaryzacja
      End If
   Elseif Menu = 12 Then                                    'anulowano wskazanie progu skokowego pedau pynnego - wczytaj z EEPROMu poprzedni nastaw
      Expr_skok = E_expr_skok
   Elseif Menu = 20 Or Menu = 21 Then                       'aktualizuj tresc7seg
      Set Update_eeprom.6
      Set Update_eeprom2.2
   Elseif Menu = 22 Or Menu = 30 Then                       'aktualizuj kolor7seg
      Set Update_eeprom.6
      Set Update_eeprom2.1
   End If
   Tryb = 1
   Menu = 0
   Key = 15
   Odlicz_blysk = 0
   Reset Led1
   Reset Led3
   Set Led2
   set  UPDATE_LCD
   Set Odswiez_lcd
Elseif Key = 3 Then
   If Menu = 1 Then                                         'aktualizuj prad_gran
      Set Update_eeprom.6
      Set Update_eeprom2.3
   Elseif Menu = 2 Then                                     'aktualizuj obr3obc
      Set Update_eeprom.6
      Set Update_eeprom2.0
   Elseif Menu = 11 Then                                    'anulowano kalibracj zakresu pedau pynnego - wczytaj z EEPROMu poprzednie nastawy
      Expr_min = E_expr_min
      Expr_max = E_expr_max
      If E_polar = 0 Then
         Reset Polaryzacja
      Else
         Set Polaryzacja
      End If
   Elseif Menu = 12 Then                                    'anulowano wskazanie progu skokowego pedau pynnego - wczytaj z EEPROMu poprzedni nastaw
      Expr_skok = E_expr_skok
   Elseif Menu = 20 Or Menu = 21 Then                       'aktualizuj tresc7seg
      Set Update_eeprom.6
      Set Update_eeprom2.2
   Elseif Menu = 22 Or Menu = 30 Then                       'aktualizuj kolor7seg
      Set Update_eeprom.6
      Set Update_eeprom2.1
   End If
   If Tryb <> 2 Then                                        'wejcie w tryb 3 lub jego ustawienia
      Tryb = 2
      Menu = 0
   Else                                                     'nawigacja po menu
      If Menu = 0 Then
         Menu = 1
      Elseif Menu = 1 Then
         Menu = 2
         Set Update_eeprom.6
         Set Update_eeprom2.3
      Elseif Menu = 2 Then
         Menu = 0
         Set Update_eeprom.6
         Set Update_eeprom2.0
      Else
         Menu = 0
      End If
   End If
   Odlicz_blysk = 0
   Key = 15
   Reset Led1
   Reset Led2
   Set Led3
   set  UPDATE_LCD
   Set Odswiez_lcd
Elseif Key = 4 Then                                         'wstecz
   If Menu > 0 Then
      'Wpisy do EEPROMu
      If Menu = 1 Then                                      'aktualizuj prad_gran
         Set Update_eeprom.6
         Set Update_eeprom2.3
      Elseif Menu = 2 Then                                  'aktualizuj obr3obc
         Set Update_eeprom.6
         Set Update_eeprom2.0
      Elseif Menu = 11 Then                                 'anulowano kalibracj zakresu pedau pynnego - wczytaj z EEPROMu poprzednie nastawy
         Expr_min = E_expr_min
         Expr_max = E_expr_max
         If E_polar = 0 Then
            Reset Polaryzacja
         Else
            Set Polaryzacja
         End If
      Elseif Menu = 12 Then                                 'anulowano wskazanie progu skokowego pedau pynnego - wczytaj z EEPROMu poprzedni nastaw
         Expr_skok = E_expr_skok
      Elseif Menu = 20 Or Menu = 21 Then                    'aktualizuj tresc7seg
         Set Update_eeprom.6
         Set Update_eeprom2.2
      Elseif Menu = 22 Or Menu = 30 Then                    'aktualizuj kolor7seg
         Set Update_eeprom.6
         Set Update_eeprom2.1
      End If
      Menu = 0
      Set Odswiez_7seg
      Set Update_lcd
      Set Odswiez_lcd
   End If
   Key = 15
Elseif Key = 5 Then                                         'ustawienia wywietlaczy 7-seg
   If Menu = 1 Then                                         'aktualizuj prad_gran
      Set Update_eeprom.6
      Set Update_eeprom2.3
      Menu = 20
   Elseif Menu = 2 Then                                     'aktualizuj obr3obc
      Set Update_eeprom.6
      Set Update_eeprom2.0
      Menu = 20
   Elseif Menu = 11 Then                                    'anulowano kalibracj zakresu pedau pynnego - wczytaj z EEPROMu poprzednie nastawy
      Expr_min = E_expr_min
      Expr_max = E_expr_max
      If E_polar = 0 Then
         Reset Polaryzacja
      Else
         Set Polaryzacja
      End If
      Menu = 20
   Elseif Menu = 12 Then                                    'anulowano wskazanie progu skokowego pedau pynnego - wczytaj z EEPROMu poprzedni nastaw
      Expr_skok = E_expr_skok
      Menu = 20
   Elseif Menu = 20 Then
      If Tresc7seg.0 = 1 Then                               'jeli 7-seg s ustawione jako wczone, przejd dalej
         Menu = 21
         Set Update_eeprom2.2
         Set Update_eeprom.6
         Odlicz_eeprom = Eeprom_write
      End If
   Elseif Menu = 21 Then
      Menu = 22
      Set Update_eeprom2.2
      Set Update_eeprom.6
   Elseif Menu = 22 Then
      Set Update_eeprom2.1
      Set Update_eeprom.6
      Menu = 0
   Elseif Menu = 30 Then
      Menu = 22
      Set Update_eeprom2.1
      Set Update_eeprom.6
      Odlicz_eeprom = Eeprom_write
   Else
      Menu = 20
      Set Odswiez_7seg
   End If
   Set Update_lcd
   Set Odswiez_lcd
   Key = 15
Elseif Key = 6 Then                                         'ustawienia pedau
   If Pn = 1 Or Pn = 2 Then
      If Menu = 1 Then                                      'aktualizuj prad_gran
         Set Update_eeprom.6
         Set Update_eeprom2.3
      Elseif Menu = 2 Then                                  'aktualizuj obr3obc
         Set Update_eeprom.6
         Set Update_eeprom2.0
      Elseif Menu = 11 Then                                 'anulowano kalibracj zakresu pedau pynnego - wczytaj z EEPROMu poprzednie nastawy
         Expr_min = E_expr_min
         Expr_max = E_expr_max
         If E_polar = 0 Then
            Reset Polaryzacja
         Else
            Set Polaryzacja
         End If
      Elseif Menu = 12 Then                                 'anulowano wskazanie progu skokowego pedau pynnego - wczytaj z EEPROMu poprzedni nastaw
         Expr_skok = E_expr_skok
      Elseif Menu = 20 Or Menu = 21 Then                    'aktualizuj tresc7seg
         Set Update_eeprom.6
         Set Update_eeprom2.2
      Elseif Menu = 22 Or Menu = 30 Then                    'aktualizuj kolor7seg
         Set Update_eeprom.6
         Set Update_eeprom2.1
      End If
      If Pn = 1 Then
         Menu = 10
      Elseif Pn = 2 Then
         If Menu = 11 Then
            Expr_min = E_expr_min
            Expr_max = E_expr_max
            If E_polar = 0 Then
               Reset Polaryzacja
            Else
               Set Polaryzacja
            End If
            Menu = 12
         Else
            Expr_min = 1023
            Expr_max = 0
            Expr_skok = E_expr_skok
            Menu = 11
         End If
      End If
      set  UPDATE_LCD
      Set Odswiez_lcd
   End If
   Key = 15
Elseif Key = 7 Then                                         'wcinito gak impulsatora
   If Menu = 10 Then
      Menu = 0
   Elseif Menu = 11 Then
      Pm_int = Expr_min + Expr_max
      Pm_int = Pm_int \ 2
      If Pm_int > Pn_value Then                          'polaryzacja (kierunek zmian napicia w zalenoci od siy nacisku)
         Reset Polaryzacja
      Else
         Set Polaryzacja
      End If
      Pm_int = Expr_max - Expr_min                          'sprawd, czy zakres jest odpowiednio wysoki
      If Pm_int > 200 Then
         Expr_min = Expr_min + 10                           'zaw nieco zakres obustronnie, aby byo pokrycie byo pewne
         Expr_max = Expr_max - 10
         Set Update_eeprom2.4
         Set Update_eeprom2.5
         Set Update_eeprom2.7
         Set Update_eeprom.6
      End If
      Menu = 12
   Elseif Menu = 12 Then
      If Pn_value > 50 And Pn_value < 1013 Then
         Expr_skok = Pn_value
         Set Update_eeprom2.6
         Set Update_eeprom.6
         Menu = 0
      End If
   Elseif Menu = 20 Then
      If Tresc7seg.0 = 1 Then
         Odlicz_eeprom = Eeprom_write
         Set Update_eeprom2.2
         Set Update_eeprom.6
         Menu = 21
      End If
   Elseif Menu = 21 Then
      Set Update_eeprom2.2
      Set Update_eeprom.6
      Menu = 22
   Elseif Menu = 22 Then
      Pm = Kolor7seg And &B00110000
      Shift Pm , Right , 4
      If Pm = 0 Then
         Menu = 30
         Set Odswiez_7seg
      Else
         Set Update_eeprom2.1
         Set Update_eeprom.6
         Menu = 0
      End If
   Elseif Menu = 30 Then
      Menu = 22
      Set Odswiez_7seg
   Elseif Menu = 1 And Tryb = 2 Then
      Set Update_eeprom.6
      Set Update_eeprom2.3
      Menu = 2
   Elseif Menu = 2 And Tryb = 2 Then
      Set Update_eeprom.6
      Set Update_eeprom2.0
      Menu = 0
   End If
   Key = 15
   Set Update_lcd
   Set Odswiez_lcd
Elseif Key = 15 Then                                        'czekaj, a zwolnione zostan wszystkie przyciski
   Set Zwolniono
   If Sw1 = 0 Then
      Reset Zwolniono
   Elseif Sw2 = 0 Then
      Reset Zwolniono
   Elseif Sw3 = 0 Then
      Reset Zwolniono
   Elseif Swback = 0 Then
      Reset Zwolniono
   Elseif Sw7seg = 0 Then
      Reset Zwolniono
   Elseif Swfoot = 0 Then
      Reset Zwolniono
   Elseif Swimp = 0 Then
      Reset Zwolniono
   End If
   If Zwolniono = 1 Then                                    'jeli zwolniono wszystkie przyciski, odblokuj obsug klawiatury
      Key = 0
   End If
End If
Loop
End

Obrot:
Disable Int0
If Pinc.4 = 0 Then                                          'CW
   Obrot_imp = 1
Else                                                        'CCW
   Obrot_imp = 2
End If
Enable Int0
Return

Czas:
'zlecanie wykonania cyklicznych pomiarw, co ok. 100ms
Incr Odlicz_pomiar
If Odlicz_pomiar = 100 Then
   Odlicz_pomiar = 0
   Set Odswiez_pom
End If

'obsuga przyciskw i eliminacja drga stykw
If Odlicz_debounce > 0 Then
   Decr Odlicz_debounce
   If Odlicz_debounce = 0 Then
      If Key = 8 Then
         If Sw1 = 0 Then
            Key = 1
         Else
            Key = 0
         End If
      Elseif Key = 9 Then
         If Sw2 = 0 Then
            Key = 2
         Else
            Key = 0
         End If
      Elseif Key = 10 Then
         If Sw3 = 0 Then
            Key = 3
         Else
            Key = 0
         End If
      Elseif Key = 11 Then
         If Swback = 0 Then
            Key = 4
         Else
            Key = 0
         End If
      Elseif Key = 12 Then
         If Sw7seg = 0 Then
            Key = 5
         Else
            Key = 0
         End If
      Elseif Key = 13 Then
         If Swfoot = 0 Then
            Key = 6
         Else
            Key = 0
         End If
      Elseif Key = 14 Then
         If Swimp = 0 Then
            Key = 7
         Else
            Key = 0
         End If
      Else
         Key = 0
      End If
   End If
End If

'obsuga podczania i odczania przecznika nonego
If Odlicz_pn > 0 Then
   Decr Odlicz_pn
   If Odlicz_pn = 0 Then
      If Pn = 4 Then
         Pn = 5
      Elseif Pn = 6 Then
         Pn = 0
      End If
   End If
End If

'obsuga mrugania diodami
If Odlicz_blysk > 0 Then
   Decr Odlicz_blysk
   If Odlicz_blysk = 0 Then
      If Tryb = 0 Then
         Reset Led2
         Reset Led3
         Set Led1
      Elseif Tryb = 1 Then
         Reset Led1
         Reset Led3
         Set Led2
      Elseif Tryb = 2 Then
         Reset Led1
         Reset Led2
         Set Led3
      End If
   End If
End If

'obsuga zapisu danych do pamici EEPROM
If Update_eeprom > 0 Then                                   'co jest do zapisania. Pilnujemy porzdku, aby wszystko zapisa i unikn konfliktw (niegotowa pami, kilka naraz itp.)
   If Odlicz_eeprom > 0 Then
      Decr Odlicz_eeprom
   Elseif Eecr.1 = 0 Then                                   'czas do odliczenia min i pami jest gotowa
      If Update_eeprom.0 = 1 Then
         If E_obr1 <> Obr1 Then
            E_obr1 = Obr1
         End If
         Reset Update_eeprom.0
      Elseif Update_eeprom.1 = 1 Then
         If E_obr1pn <> Obr1pn Then
            E_obr1pn = Obr1pn
         End If
         Reset Update_eeprom.1
      Elseif Update_eeprom.2 = 1 Then
         If E_obr2 <> Obr2 Then
            E_obr2 = Obr2
         End If
         Reset Update_eeprom.2
      Elseif Update_eeprom.3 = 1 Then
         If E_obr2pn <> Obr2pn Then
            E_obr2pn = Obr2pn
         End If
         Reset Update_eeprom.3
      Elseif Update_eeprom.4 = 1 Then
         If E_obr3 <> Obr3 Then
            E_obr3 = Obr3
         End If
         Reset Update_eeprom.4
      Elseif Update_eeprom.5 = 1 Then
         If E_obr3pn <> Obr3pn Then
            E_obr3pn = Obr3pn
         End If
         Reset Update_eeprom.5
      Elseif Update_eeprom.6 = 1 Then                       'co jeszcze jest - trzeba przeszuka drug zmienn
         Reset Update_eeprom.7                              'na wypadek bugw lub bdw
         If Update_eeprom2.0 = 1 Then
            If E_obr3obc <> Obr3obc Then
               E_obr3obc = Obr3obc
            End If
            Reset Update_eeprom2.0
         Elseif Update_eeprom2.1 = 1 Then
            If E_kolor7seg <> Kolor7seg Then
               E_kolor7seg = Kolor7seg
            End If
            Reset Update_eeprom2.1
         Elseif Update_eeprom2.2 = 1 Then
            If E_tresc7seg <> Tresc7seg Then
               E_tresc7seg = Tresc7seg
            End If
            Reset Update_eeprom2.2
         Elseif Update_eeprom2.3 = 1 Then
            If E_prad_gran <> Prad_gran Then
               E_prad_gran = Prad_gran
            End If
            Reset Update_eeprom2.3
         Elseif Update_eeprom2.4 = 1 Then
            If E_expr_min <> Expr_min Then
               E_expr_min = Expr_min
            End If
            Reset Update_eeprom2.4
         Elseif Update_eeprom2.5 = 1 Then
            If E_expr_max <> Expr_max Then
               E_expr_max = Expr_max
            End If
            Reset Update_eeprom2.5
         Elseif Update_eeprom2.6 = 1 Then
            If E_expr_skok <> Expr_skok Then
               E_expr_skok = Expr_skok
            End If
            Reset Update_eeprom2.6
         Elseif Update_eeprom2.7 = 1 Then
            If Polaryzacja = 1 And E_polar = 0 Then
               E_polar = 1
            Elseif Polaryzacja = 0 And E_polar > 0 Then
               E_polar = 0
            End If
            Reset Update_eeprom2.7
         Else
            Reset Update_eeprom.6
         End If
      End If
   End If
End If
Return

Kody7seg:
Data &B00000011 , &B10011111 , &B00100101 , &B00001101 , &B10011001,       '0-4
Data &B01001001 , &B01000001 , &B00011111 , &B00000001 , &B00001001,       '5-9
Data &B11111111                                             'puste